/* Scrivere un programma per la gestione delle iscrizioni ad un'associazione culturale e delle prenotazioni agli eventi culturali.
Gli iscritti sono caratterizzati da: codice fiscale, numero di telefono, et e titolo di studio (0=elementare, 1=media, 2=diploma, 3=laurea).
Le prenotazioni sono caratterizzate da: codice fiscale, codice evento,  data evento, tipo di evento (0,..4). 
Gli iscritti sono inseriti in un vettore di 4 liste,  una per ogni tipo di iscritto. 
Le prenotazioni sono inserite in una tabella allocata dinamicamente avente 5 righe, una  per ogni tipo di evento.

Nel programma  presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento ordinato rispetto al codice fiscale nel vettore di liste di un nuovo iscritto; 
2.	Visualizzazione degli iscritti con un certo titolo di studio;
3.	Inserimento di una nuova prenotazione;
4.	Ricerca di una prenotazione;
5.	Salvataggio su file delle prenotazioni;

All'avvio del programma inizializzare la tabella delle prenotazioni leggendo da file le prenotazioni precedentemente salvate.

Liberare la memoria allocata dinamicamente.


*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct prenotazione{
       char cod_fisc[16];
       int codice;
       char data[11];
       int tipo;
};

struct iscritto{
       char cod_fisc[16];
       char numero[15];
       int eta;
       int titolo; 
       };
       
struct atomo{
       struct iscritto dato;
       struct atomo*next; 
       };
 
void inizializza(struct prenotazione *T[5], int *N);
void leggi_iscritto(struct iscritto *p);
void ins_iscritto(struct atomo **L, struct iscritto p);
void vis_iscritto(struct atomo *L[4]);
void ins_prenotazione(struct prenotazione *T[5], int *N);
void ricerca(struct prenotazione *T[5],int N[5]);
void salva(struct prenotazione *T[5],int N[5]);
void da_testa(struct atomo **p);
      
main(){
      struct atomo *L[4];
      struct iscritto p;
      struct prenotazione *T[5],t;
      int N[5],scelta,i;
      
      for(i=0;i<4;i++)
           L[i]=NULL;
      for(i=0;i<5;i++)
      {
          T[i]=NULL;
          N[i]=0;
      }
      
      inizializza(T,N);

     do{
         printf("\n)Scegli tra: \n");
         printf("1)Inserisci una nuovo iscritto\n2)Visualizza gli iscritti con un certo titolo di studio\n");
         printf("3)Inserisci una nuova prenotazione\n4)Ricerca prenotazione\n");
         printf("5)Salva su file le prenotazioni\n0)Termina programma\n");
         scanf("%d",&scelta);
         switch(scelta){
                       case 1: leggi_iscritto(&p);
                               i=p.titolo;
                               ins_iscritto(&L[i],p);
                               break;
                       case 2: vis_iscritto(L);
                               break;
                       case 3: ins_prenotazione(T,N);                             
                               break;
                       case 4: ricerca(T,N);
                               break;
                       case 5: salva(T,N);
                               break;
         }
         }while(scelta!=0);
        
         for(i=0;i<4;i++)
            while(L[i]!=NULL)
              da_testa(&L[i]);
              
         for(i=0;i<5;i++)
         free(T[i]);
}

void inizializza(struct prenotazione *T[5], int *N){
     int tipo;
     struct prenotazione a;
     struct prenotazione *aux;
     FILE *pf;
     
     pf=fopen("prenotazioni.txt","r");
     if(pf){  
           while(fread(&a,sizeof(struct prenotazione),1,pf)){
              tipo=a.tipo;
              aux=realloc(T[tipo],sizeof(struct prenotazione)*(N[tipo]+1));
              
              if(aux==NULL)
                 return;
              T[tipo]=aux;
              T[tipo][N[tipo]]=a;
              N[tipo]++;
              
           }
          fclose(pf);
       } 
     else printf("\n Il file non e' ancora stato creato!!\n");
}

void leggi_iscritto(struct iscritto *p){              
     printf("Codice fiscale: \n");                     
     scanf("%s", p->cod_fisc);                         
     printf("Numero di telefono: \n");                              
     scanf("%s", p->numero);
     printf("Eta': \n");
     scanf("%d", &p->eta);
     printf("Titolo di studio: \n");
     scanf("%d", &p->titolo); 
}     
void ins_iscritto(struct atomo **L, struct iscritto p){
  struct atomo *x, *l1, *l2;
  int i;
  
  x=malloc(sizeof(struct atomo));
  if(x==NULL)
  return;
  
  x->dato=p;
  if(*L==NULL || strcmp(p.cod_fisc,(*L)->dato.cod_fisc)<0){     
     x->next=*L;
     *L=x;
     return;
  }
  
  l2=*L;
  l1=l2->next;
  while(l1)
   if(strcmp(p.cod_fisc,l1->dato.cod_fisc)<0)
        break;
   else { 
         l2=l1;
         l1=l1->next;
        }
        
  x->next=l1;
  l2->next=x; 
}

void vis_iscritto(struct atomo *L[4]){                   
        	int titolo;                        
        	struct atomo *aux;
        
        	printf("Inserisci il titolo di studio(0..3)\n");
        	scanf("%d",&titolo);
        	        
        	aux=L[titolo];
        	while(aux!=NULL){
        	   if(aux->dato.titolo==titolo){	
                   printf("Codice fiscale: %s\n",aux->dato.cod_fisc);
        		   printf("Numero di telefono: %d\n",aux->dato.numero);
        		   printf("Eta': %d\n",aux->dato.eta);
                }
        	   aux=aux->next;
             }	
}

void ins_prenotazione(struct prenotazione *T[5], int *N){     
     struct prenotazione *aux,a;                        
     int tipo;
     
     printf("- Codice fiscale: ");
     scanf("%s",a.cod_fisc);
     printf("- Codice evento: ");
     scanf("%d",&a.codice);
     printf("- Data evento: ");
     scanf("%s",a.data);
     printf("- Tipo di evento (0..4): ");
     scanf("%d",&a.tipo);
     
     tipo=a.tipo;
     aux=realloc(T[tipo],sizeof(struct prenotazione)*(N[tipo]+1));
     if(aux==NULL){
          printf("Memoria non allocata\n");
          return;
     }
     T[tipo]=aux;
     T[tipo][N[tipo]]=a;
     N[tipo]++;
}

void ricerca(struct prenotazione *T[5],int N[5]){              
     char cod_fisc[16];                                  
     int tipo,i;
     
     printf("Tipo evento: ");
     scanf("%d",&tipo);
     printf("Codice fiscale: ");
     scanf("%s",cod_fisc);
       
     for(i=0;i<N[tipo];i++)
        if(strcmp(cod_fisc,T[tipo][i].cod_fisc)==0)
                {printf("Trovato\n");
                 printf("Data evento: %d\n",T[tipo][i].data);
                 printf("Codice evento: %d\n",T[tipo][i].codice);
                 return;
                }                
     printf("Non trovato");
}

void salva(struct prenotazione *T[5],int N[5]){
 	 FILE *pf;
 	 int i,g;
     
     
     pf=fopen("prenotazioni.txt","w");
     if(pf)
       {for(i=0;i<5;i++)
            for(g=0;g<N[i];g++)
                fwrite(&T[i][g],sizeof(struct prenotazione),1,pf);
        fclose(pf);
       }
     else printf("Errore in scrittura file");
}

void da_testa(struct atomo **p){ 
     struct atomo *a;
  
  a=*p;
  *p=a->next;
  free(a); 
}
